#include "Arduino.h"

//MICRO
//USART senden Version 1
//09.05.2017 by F. König
//UDRE1: Bit zeigt an ob der Sendepuffer bereit ist ein neues zu sendendes Bit aufzunehmen.
//UBRR1: Kommunikationsgeschwindigkeit muss dem Register mitgeteilt werden. UBRR=F_CPU/BAUDATE/16-1
//UDR1: Hier werden Daten zwischen USART und CPU übertragen. Physikalisch zwei Register. Vollduplexbetrieb(senden/empfangen gleichzeitig möglich)
//UCSR1A, UCSR1B, UCSR1C  notwendige Register
//U2X1: Bit wird für asynchronen Mode genutzt. 1=Baudratendivisor von 16 auf 8.
//RXEN1: Bit setzen für Empfangsbetrieb.
//TXEN1: Bit setzen für Sendebetrieb.
//USBS1: 0= 1 Stopbit; 1= 2 Stopbit.
//UCSZ12 - UCSZ10: Datenframe festlegen

#define F_CPU 16000000  
#define BAUDRATE 9600   

unsigned char akku = 0;
unsigned char l,m,r; //Variablen für Anzeige linke, mitte, rechts
unsigned int baudregister = (F_CPU/8/BAUDRATE)-1;//103
void setup() 
{    
    //DDRB &= (0<<PB6); 
    
    //setzen der Baudrate
    UBRR0H = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
    UBRR0L = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
    //UBRR1 = baudregister;
    
    
    UCSR0A = (1<<U2X0);
    //Einschalten des Senders und Empfänger | UCSZ12 Character Size
    UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (0<<UCSZ02);
    //UMSEL11 = 0, UMSEL10 = 0 Asynchronous USART | USBS1 = 0 ein Stopbit | UCSZ11 = 1, UCSZ10 = 1 Character Size 8-bit
    UCSR0C = (0<<UMSEL01) | (0<<UMSEL00) | (0<<USBS0) | (1<<UCSZ01) | (1<<UCSZ00);
    
}

void loop() 
{
  l = akku/100;
  m = (akku%100)/10;
  r = akku%10;

   while( !(UCSR0A & (1<<UDRE0)) ); //Warten bis der Uebertragungspuffer leer ist
        UDR0 = l+48;                    //Daten in den Puffer schreiben und übertragen
        while( !(UCSR0A & (1<<UDRE0)) ); 
        UDR0 = m+48;
        while( !(UCSR0A & (1<<UDRE0)) );
        UDR0 = r+48;
        while( !(UCSR0A & (1<<UDRE0)) );
      UDR0 = '\n';
        while( !(UCSR0A & (1<<UDRE0)) );
      UDR0 = '\r';
     akku++;
  delay(1000);
  //Serial.print(l);
  //Serial.print(m);
  //Serial.print(r);
  //Serial.println();
  //delay(1000);
  //if(UCSR1A & (1<<UDRE1))
  //UDR1 = akku;
  
  
  //Serial.println(baudregister);
 
}
